# std::basic_ios< _CharT, _Traits > Class Template Reference

Virtual base class for all stream classes. More...

`#include <basic_ios.h>`

Inheritance diagram for std::basic_ios< _CharT, _Traits >:

[legend]
Collaboration diagram for std::basic_ios< _CharT, _Traits >:

[legend]
List of all members.

## Public Types

typedef _CharT | char_type
typedef _Traits::int_type | int_type
typedef _Traits::pos_type | pos_type
typedef _Traits::off_type | off_type
typedef _Traits | traits_type

## Public Methods

iostate | rdstate () const
| Returns the error state of the stream buffer.
void | clear (iostate __state=goodbit)
| [Re]sets the error state.
void | setstate (iostate __state)
| Sets additional flags in the error state.
bool | good () const
| Fast error checking.
bool | eof () const
| Fast error checking.
bool | fail () const
| Fast error checking.
bool | bad () const
| Fast error checking.
iostate | exceptions () const
| Throwing exceptions on errors.
void | exceptions (iostate __except)
| Throwing exceptions on errors.
| basic_ios (basic_streambuf< _CharT, _Traits > *__sb)
| Constructor performs initialization.
virtual | ~basic_ios ()
| Empty.
basic_ostream< _CharT, _Traits > * | tie () const
| Fetches the current tied stream.
basic_ostream< _CharT, _Traits > * | tie (basic_ostream< _CharT, _Traits > *__tiestr)
| Ties this stream to an output stream.
basic_streambuf< _CharT, _Traits > * | rdbuf () const
| Accessing the underlying buffer.
basic_streambuf< _CharT, _Traits > * | rdbuf (basic_streambuf< _CharT, _Traits > *__sb)
| Changing the underlying buffer.
basic_ios & | copyfmt (const basic_ios &__rhs)
char_type | fill () const
| Retreives the "empty" character.
char_type | fill (char_type __ch)
| Sets a new "empty" character.
locale | imbue (const locale &__loc)
| Moves to a new locale.
char | narrow (char_type __c, char __dfault) const
| Squeezes characters.
char_type | widen (char __c) const
| Widens characters.
| operator void * () const
| The quick-and-easy status check.
bool | operator! () const
| The quick-and-easy status check.

## Protected Methods

| basic_ios ()
| Empty.
void | init (basic_streambuf< _CharT, _Traits > *__sb)
| All setup is performed here.

## Detailed Description

### template<typename _CharT, typename _Traits>
class std::basic_ios< _CharT, _Traits >

Virtual base class for all stream classes.

Most of the member functions called dispatched on stream objects (e.g., `std::cout.foo(bar);)` are consolidated in this class.

Definition at line 53 of file basic_ios.h.

## Member Typedef Documentation

template<typename _CharT, typename _Traits>
typedef _CharT std::basic_ios< _CharT, _Traits >::char_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented in std::basic_ifstream< _CharT, _Traits > , std::basic_ofstream< _CharT, _Traits > , std::basic_fstream< _CharT, _Traits > , std::basic_istream< _CharT, _Traits > , std::basic_ostream< _CharT, _Traits > , std::basic_istringstream< _CharT, _Traits, _Alloc > , std::basic_ostringstream< _CharT, _Traits, _Alloc > , std::basic_stringstream< _CharT, _Traits, _Alloc > , std::basic_istream< char, _Traits > , std::basic_istream< char > , std::basic_ostream< char, _Traits > , and std::basic_ostream< char > .

Definition at line 62 of file basic_ios.h.

Referenced by std::basic_ios< char, _Traits >::fill() , and std::basic_ios< _CharT, _Traits >::widen() .

template<typename _CharT, typename _Traits>
typedef _Traits::int_type std::basic_ios< _CharT, _Traits >::int_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented in std::basic_ifstream< _CharT, _Traits > , std::basic_ofstream< _CharT, _Traits > , std::basic_fstream< _CharT, _Traits > , std::basic_istream< _CharT, _Traits > , std::basic_ostream< _CharT, _Traits > , std::basic_istringstream< _CharT, _Traits, _Alloc > , std::basic_ostringstream< _CharT, _Traits, _Alloc > , std::basic_stringstream< _CharT, _Traits, _Alloc > , std::basic_istream< char, _Traits > , std::basic_istream< char > , std::basic_ostream< char, _Traits > , and std::basic_ostream< char > .

Definition at line 63 of file basic_ios.h.

template<typename _CharT, typename _Traits>
typedef _Traits::off_type std::basic_ios< _CharT, _Traits >::off_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented in std::basic_ifstream< _CharT, _Traits > , std::basic_ofstream< _CharT, _Traits > , std::basic_fstream< _CharT, _Traits > , std::basic_istream< _CharT, _Traits > , std::basic_ostream< _CharT, _Traits > , std::basic_istringstream< _CharT, _Traits, _Alloc > , std::basic_ostringstream< _CharT, _Traits, _Alloc > , std::basic_stringstream< _CharT, _Traits, _Alloc > , std::basic_istream< char, _Traits > , std::basic_istream< char > , std::basic_ostream< char, _Traits > , and std::basic_ostream< char > .

Definition at line 65 of file basic_ios.h.

template<typename _CharT, typename _Traits>
typedef _Traits::pos_type std::basic_ios< _CharT, _Traits >::pos_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented in std::basic_ifstream< _CharT, _Traits > , std::basic_ofstream< _CharT, _Traits > , std::basic_fstream< _CharT, _Traits > , std::basic_istream< _CharT, _Traits > , std::basic_ostream< _CharT, _Traits > , std::basic_istringstream< _CharT, _Traits, _Alloc > , std::basic_ostringstream< _CharT, _Traits, _Alloc > , std::basic_stringstream< _CharT, _Traits, _Alloc > , std::basic_istream< char, _Traits > , std::basic_istream< char > , std::basic_ostream< char, _Traits > , and std::basic_ostream< char > .

Definition at line 64 of file basic_ios.h.

template<typename _CharT, typename _Traits>
typedef _Traits std::basic_ios< _CharT, _Traits >::traits_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented in std::basic_ifstream< _CharT, _Traits > , std::basic_ofstream< _CharT, _Traits > , std::basic_fstream< _CharT, _Traits > , std::basic_istream< _CharT, _Traits > , std::basic_ostream< _CharT, _Traits > , std::basic_istringstream< _CharT, _Traits, _Alloc > , std::basic_ostringstream< _CharT, _Traits, _Alloc > , std::basic_stringstream< _CharT, _Traits, _Alloc > , std::basic_istream< char, _Traits > , std::basic_istream< char > , std::basic_ostream< char, _Traits > , and std::basic_ostream< char > .

Definition at line 66 of file basic_ios.h.

## Constructor & Destructor Documentation

template<typename _CharT, typename _Traits>
std::basic_ios< _CharT, _Traits >::basic_ios | ( | basic_streambuf< _CharT, _Traits > * | __sb | ) | `[inline, explicit]`

| Constructor performs initialization. The parameter is passed by derived streams. Definition at line 240 of file basic_ios.h.

template<typename _CharT, typename _Traits>
virtual std::basic_ios< _CharT, _Traits >::~basic_ios | ( |  | ) | `[inline, virtual]`

| Empty. The destructor does nothing. More specifically, it does not destroy the streambuf held by rdbuf(). Definition at line 250 of file basic_ios.h.

template<typename _CharT, typename _Traits>
std::basic_ios< _CharT, _Traits >::basic_ios | ( |  | ) | `[inline, protected]`

| Empty. The default constructor does nothing and is not normally accessible to users. Definition at line 411 of file basic_ios.h.

## Member Function Documentation

template<typename _CharT, typename _Traits>
bool std::basic_ios< _CharT, _Traits >::bad | ( |  | ) | const`[inline]`

Fast error checking.

Returns:
  True if the badbit is set.

Note that other iostate flags may also be set.

Definition at line 181 of file basic_ios.h.

template<typename _CharT, typename _Traits>
void std::basic_ios< _CharT, _Traits >::clear | ( | iostate | __state = goodbit | ) |

[Re]sets the error state.

Parameters:

  state | The new state flag(s) to set.

See std::ios_base::iostate for the possible bit values. Most users will not need to pass an argument.

Definition at line 39 of file basic_ios.tcc.

References std::ios_base::badbit , std::basic_ios< _CharT, _Traits >::exceptions() , std::basic_ios< _CharT, _Traits >::rdbuf() , and std::basic_ios< _CharT, _Traits >::rdstate() .

Referenced by std::basic_ios< char, _Traits >::exceptions() , std::basic_ios< _CharT, _Traits >::rdbuf() , and std::basic_ios< char, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_ios< _CharT, _Traits > & std::basic_ios< _CharT, _Traits >::copyfmt | ( | const basic_ios< _CharT, _Traits > & | __rhs | ) |

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 61 of file basic_ios.tcc.

References std::ios_base::_M_callbacks , std::ios_base::_M_word , std::ios_base::_M_word_size , std::basic_ios< _CharT, _Traits >::exceptions() , std::basic_ios< _CharT, _Traits >::fill() , std::ios_base::flags() , std::ios_base::precision() , std::basic_ios< _CharT, _Traits >::tie() , and std::ios_base::width() .

template<typename _CharT, typename _Traits>
bool std::basic_ios< _CharT, _Traits >::eof | ( |  | ) | const`[inline]`

Fast error checking.

Returns:
  True if the eofbit is set.

Note that other iostate flags may also be set.

Definition at line 160 of file basic_ios.h.

template<typename _CharT, typename _Traits>
void std::basic_ios< _CharT, _Traits >::exceptions | ( | iostate | __except | ) | `[inline]`

Throwing exceptions on errors.

Parameters:

  except | The new exceptions mask.

By default, error flags are set silently. You can set an exceptions mask for each stream; if a bit in the mask becomes set in the error flags, then an exception of type std::ios_base::failure is thrown.

If the error flage is already set when the exceptions mask is added, the exception is immediately thrown. Try running the following under GCC 3.1 or later:

      #include <iostream>
      #include <fstream>
      #include <exception>

      int main()
      {
          std::set_terminate (__gnu_cxx::__verbose_terminate_handler);

          std::ifstream f ("/etc/motd");

          std::cerr << "Setting badbit\n";
          f.setstate (std::ios_base::badbit);

          std::cerr << "Setting exception mask\n";
          f.exceptions (std::ios_base::badbit);
      }

Definition at line 227 of file basic_ios.h.

template<typename _CharT, typename _Traits>
iostate std::basic_ios< _CharT, _Traits >::exceptions | ( |  | ) | const`[inline]`

Throwing exceptions on errors.

Returns:
  The current exceptions mask.

This changes nothing in the stream. See the one-argument version of exceptions(iostate) for the meaning of the return value.

Definition at line 192 of file basic_ios.h.

Referenced by std::basic_ios< _CharT, _Traits >::clear() , std::basic_ios< _CharT, _Traits >::copyfmt() , std::basic_istream< _CharT, _Traits >::get() , std::basic_istream< _CharT, _Traits >::getline() , std::basic_istream< _CharT, _Traits >::ignore() , std::operator<<() , std::basic_ostream< _CharT, _Traits >::operator<<() , std::operator>>() , std::basic_istream< _CharT, _Traits >::operator>>() , std::basic_istream< _CharT, _Traits >::peek() , std::basic_istream< _CharT, _Traits >::putback() , std::basic_istream< _CharT, _Traits >::read() , std::basic_istream< _CharT, _Traits >::readsome() , std::basic_istream< _CharT, _Traits >::sync() , and std::basic_istream< _CharT, _Traits >::unget() .

template<typename _CharT, typename _Traits>
bool std::basic_ios< _CharT, _Traits >::fail | ( |  | ) | const`[inline]`

Fast error checking.

Returns:
  True if either the badbit or the failbit is set.

Checking the badbit in fail() is historical practice. Note that other iostate flags may also be set.

Definition at line 171 of file basic_ios.h.

Referenced by std::basic_ios< char, _Traits >::operator void *() , std::basic_ios< char, _Traits >::operator!() , std::basic_istream< _CharT, _Traits >::seekg() , std::basic_ostream< _CharT, _Traits >::seekp() , std::basic_istream< _CharT, _Traits >::tellg() , and std::basic_ostream< _CharT, _Traits >::tellp() .

template<typename _CharT, typename _Traits>
char_type std::basic_ios< _CharT, _Traits >::fill | ( | char_type | __ch | ) | `[inline]`

Sets a new "empty" character.

Parameters:

  ch | The new character.

Returns:
  The previous fill character.

The fill character is used to fill out space when P+ characters have been requested (e.g., via setw), Q characters are actually used, and Q<P. It defaults to a space (' ') in the current locale.

Definition at line 343 of file basic_ios.h.

template<typename _CharT, typename _Traits>
char_type std::basic_ios< _CharT, _Traits >::fill | ( |  | ) | const`[inline]`

Retreives the "empty" character.

Returns:
  The current fill character.

It defaults to a space (' ') in the current locale.

Definition at line 323 of file basic_ios.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt() , std::basic_ios< char, _Traits >::fill() , std::operator<<() , and std::basic_ostream< _CharT, _Traits >::operator<<() .

template<typename _CharT, typename _Traits>
bool std::basic_ios< _CharT, _Traits >::good | ( |  | ) | const`[inline]`

Fast error checking.

Returns:
  True if no error flags are set.

A wrapper around rdstate.

Definition at line 150 of file basic_ios.h.

Referenced by std::basic_istream< _CharT, _Traits >::sentry::sentry() .

template<typename _CharT, typename _Traits>
locale std::basic_ios< _CharT, _Traits >::imbue | ( | const locale & | __loc | ) |

Moves to a new locale.

Parameters:

  loc | The new locale.

Returns:
  The previous locale.

Calls `ios_base::imbue(loc),` and if a stream buffer is associated with this stream, calls that buffer's `pubimbue(loc).`

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/22_locale/howto.html

Reimplemented from std::ios_base .

Definition at line 128 of file basic_ios.tcc.

References std::basic_ios< _CharT, _Traits >::rdbuf() .

template<typename _CharT, typename _Traits>
void std::basic_ios< _CharT, _Traits >::init | ( | basic_streambuf< _CharT, _Traits > * | __sb | ) | `[protected]`

All setup is performed here.

This is called from the public constructor. It is not virtual and cannot be redefined.

Definition at line 140 of file basic_ios.tcc.

References std::ios_base::badbit , and std::ios_base::goodbit .

Referenced by std::basic_fstream< _CharT, _Traits >::basic_fstream() , std::basic_ifstream< _CharT, _Traits >::basic_ifstream() , std::basic_ios< char, _Traits >::basic_ios() , std::basic_istream< char >::basic_istream() , std::basic_istringstream< _CharT, _Traits, _Alloc >::basic_istringstream() , std::basic_ofstream< _CharT, _Traits >::basic_ofstream() , std::basic_ostream< char >::basic_ostream() , std::basic_ostringstream< _CharT, _Traits, _Alloc >::basic_ostringstream() , and std::basic_stringstream< _CharT, _Traits, _Alloc >::basic_stringstream() .

template<typename _CharT, typename _Traits>
char std::basic_ios< _CharT, _Traits >::narrow | ( | char_type | __c,
|  | char | __dfault
| ) | const

Squeezes characters.

Parameters:

  c | The character to narrow.
  dfault | The character to narrow.

Returns:
  The narrowed character.

Maps a character of `char_type` to a character of `char,` if possible.

Returns the result of

        std::use_facet< ctype<char_type> >(getloc()).narrow(c,dfault)

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/22_locale/howto.html

Definition at line 107 of file basic_ios.tcc.

Referenced by std::operator>>() .

template<typename _CharT, typename _Traits>
std::basic_ios< _CharT, _Traits >::operator void * | ( |  | ) | const`[inline]`

| The quick-and-easy status check. This allows you to write constructs such as "if (!a_stream) ..." and "while (a_stream) ..." Definition at line 104 of file basic_ios.h.

template<typename _CharT, typename _Traits>
bool std::basic_ios< _CharT, _Traits >::operator! | ( |  | ) | const`[inline]`

| The quick-and-easy status check. This allows you to write constructs such as "if (!a_stream) ..." and "while (a_stream) ..." Definition at line 108 of file basic_ios.h.

template<typename _CharT, typename _Traits>
basic_streambuf< _CharT, _Traits > * std::basic_ios< _CharT, _Traits >::rdbuf | ( | basic_streambuf< _CharT, _Traits > * | __sb | ) |

Changing the underlying buffer.

Parameters:

  sb | The new stream buffer.

Returns:
  The previous stream buffer.

Associates a new buffer with the current stream, and clears the error state.

Due to historical accidents which the LWG refuses to correct, the I/O library suffers from a design error: this function is hidden in derived classes by overrides of the zero-argument `rdbuf(),` which is non-virtual for hysterical raisins. As a result, you must use explicit qualifications to access this function via any derived class.

Definition at line 51 of file basic_ios.tcc.

References std::basic_ios< _CharT, _Traits >::clear() .

template<typename _CharT, typename _Traits>
basic_streambuf<_CharT, _Traits>* std::basic_ios< _CharT, _Traits >::rdbuf | ( |  | ) | const`[inline]`

Accessing the underlying buffer.

Returns:
  The current stream buffer.

This does not change the state of the stream.

Reimplemented in std::basic_ifstream< _CharT, _Traits > , std::basic_ofstream< _CharT, _Traits > , std::basic_fstream< _CharT, _Traits > , std::basic_istringstream< _CharT, _Traits, _Alloc > , std::basic_ostringstream< _CharT, _Traits, _Alloc > , and std::basic_stringstream< _CharT, _Traits, _Alloc > .

Definition at line 289 of file basic_ios.h.

Referenced by std::basic_ios< _CharT, _Traits >::clear() , std::basic_ostream< _CharT, _Traits >::flush() , std::basic_istream< _CharT, _Traits >::get() , std::basic_istream< _CharT, _Traits >::getline() , std::basic_istream< _CharT, _Traits >::ignore() , std::basic_ios< _CharT, _Traits >::imbue() , std::basic_istream< _CharT, _Traits >::operator>>() , std::operator>>() , std::basic_istream< _CharT, _Traits >::peek() , std::basic_ostream< _CharT, _Traits >::put() , std::basic_istream< _CharT, _Traits >::putback() , std::basic_istream< _CharT, _Traits >::read() , std::basic_istream< _CharT, _Traits >::readsome() , std::basic_istream< _CharT, _Traits >::seekg() , std::basic_ostream< _CharT, _Traits >::seekp() , std::basic_istream< _CharT, _Traits >::sentry::sentry() , std::basic_istream< _CharT, _Traits >::sync() , std::basic_istream< _CharT, _Traits >::tellg() , std::basic_ostream< _CharT, _Traits >::tellp() , std::basic_istream< _CharT, _Traits >::unget() , std::ws() , and std::basic_ostream< _CharT, _Traits >::sentry::~sentry() .

template<typename _CharT, typename _Traits>
iostate std::basic_ios< _CharT, _Traits >::rdstate | ( |  | ) | const`[inline]`

Returns the error state of the stream buffer.

Returns:
  A bit pattern (well, isn't everything?)

See std::ios_base::iostate for the possible bit values. Most users will call one of the interpreting wrappers, e.g., good().

Definition at line 120 of file basic_ios.h.

Referenced by std::basic_ios< char, _Traits >::bad() , std::basic_ios< _CharT, _Traits >::clear() , std::basic_ios< char, _Traits >::eof() , std::basic_ios< char, _Traits >::fail() , and std::basic_ios< char, _Traits >::good() .

template<typename _CharT, typename _Traits>
void std::basic_ios< _CharT, _Traits >::setstate | ( | iostate | __state | ) | `[inline]`

Sets additional flags in the error state.

Parameters:

  state | The additional state flag(s) to set.

See std::ios_base::iostate for the possible bit values.

Definition at line 140 of file basic_ios.h.

Referenced by std::basic_fstream< _CharT, _Traits >::close() , std::basic_ofstream< _CharT, _Traits >::close() , std::basic_ifstream< _CharT, _Traits >::close() , std::basic_ostream< _CharT, _Traits >::flush() , std::basic_istream< _CharT, _Traits >::get() , std::basic_istream< _CharT, _Traits >::getline() , std::basic_istream< _CharT, _Traits >::ignore() , std::basic_fstream< _CharT, _Traits >::open() , std::basic_ofstream< _CharT, _Traits >::open() , std::basic_ifstream< _CharT, _Traits >::open() , std::operator<<() , std::basic_ostream< _CharT, _Traits >::operator<<() , std::basic_istream< _CharT, _Traits >::operator>>() , std::operator>>() , std::basic_istream< _CharT, _Traits >::peek() , std::basic_ostream< _CharT, _Traits >::put() , std::basic_istream< _CharT, _Traits >::putback() , std::basic_istream< _CharT, _Traits >::read() , std::basic_istream< _CharT, _Traits >::readsome() , std::basic_istream< _CharT, _Traits >::seekg() , std::basic_ostream< _CharT, _Traits >::seekp() , std::basic_istream< _CharT, _Traits >::sentry::sentry() , std::basic_istream< _CharT, _Traits >::sync() , std::basic_istream< _CharT, _Traits >::unget() , std::ws() , and std::basic_ostream< _CharT, _Traits >::sentry::~sentry() .

template<typename _CharT, typename _Traits>
basic_ostream<_CharT, _Traits>* std::basic_ios< _CharT, _Traits >::tie | ( | basic_ostream< _CharT, _Traits > * | __tiestr | ) | `[inline]`

Ties this stream to an output stream.

Parameters:

  tiestr | The output stream.

Returns:
  The previously tied output stream, or NULL if the stream was not tied.

This sets up a new tie; see tie() for more.

Definition at line 275 of file basic_ios.h.

template<typename _CharT, typename _Traits>
basic_ostream<_CharT, _Traits>* std::basic_ios< _CharT, _Traits >::tie | ( |  | ) | const`[inline]`

Fetches the current tied stream.

Returns:
  A pointer to the tied stream, or NULL if the stream is not tied.

A stream may be tied (or synchronized) to a second output stream. When this stream performs any I/O, the tied stream is first flushed. For example, `std::cin` is tied to `std::cout.`

Definition at line 263 of file basic_ios.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt() , and std::basic_istream< _CharT, _Traits >::sentry::sentry() .

template<typename _CharT, typename _Traits>
_CharT std::basic_ios< _CharT, _Traits >::widen | ( | char | __c | ) | const

Widens characters.

Parameters:

  c | The character to widen.

Returns:
  The widened character.

Maps a character of `char` to a character of `char_type.`

Returns the result of

        std::use_facet< ctype<char_type> >(getloc()).widen(c)

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/22_locale/howto.html

Definition at line 117 of file basic_ios.tcc.

References std::basic_ios< _CharT, _Traits >::char_type .

Referenced by std::endl() , std::basic_ios< char, _Traits >::fill() , and std::operator<<() .

The documentation for this class was generated from the following files:

- basic_ios.h
- basic_ios.tcc